package archetype

type Adapter interface {
	Init(cfg *Config)
	Name() string
  EditableSlugs() bool
  BuildOptions() ([]string)
	GetConfig(key string) (interface{}, error)
	SetConfig(key string, value interface{}) error
	ListPages() map[string]string
	GetPage(string) (Page, error)
	FormatPage(string) string
	FormattingHelp() string
	CreatePage(slug, title, content string) error
	SavePage(oldSlug, newSlug, title, content string) error
	DeletePage(slug string) error
	Build(buildOptions map[string]string) (bool, string)
}
